<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 8</a>

    <script>

        class Node {
            constructor(data) {
                this.data = data;
                this.left = null;
                this.right = null;
            }

            antecesor(n1, n2) {
                return root.buscarAnte(root, n1, n2);
            }

            buscarAnte(node,n1,n2) {
                if (node === null)
                    return null;
                    
                if (node.data === n1 || node.data === n2)
                    return node;

                let left_lca = root.buscarAnte(node.left,  n1, n2),
                   right_lca = root.buscarAnte(node.right, n1, n2);

                if (left_lca != null && right_lca != null)
                    return node;

                return (left_lca != null) 
                    ? left_lca
                    : right_lca;
            }
        }

        let root = new Node(1); 
        root.left = new Node(2);
        root.right = new Node(3);
        root.left.left = new Node(4);
        root.left.right = new Node(5);
        root.right.left = new Node(6);
        root.right.right = new Node(7);
        console.log(root);

        console.log(`El Nodo antecesor de (4 , 5) es: ${root.antecesor(4,5).data}`);
        console.log(`El Nodo antecesor de (4 , 6) es: ${root.antecesor(4,6).data}`);
        console.log(`El Nodo antecesor de (2 , 4) es: ${root.antecesor(2,5).data}`)
        

    </script>
    
</body>
</html>